class Mammoth
{
   var _mc;
   var _mc2;
   var _mc2dx;
   var _mc2dy;
   var _mc3;
   var _mc3dx;
   var _mc3dy;
   var windposx;
   var windposy;
   static var _choclimit;
   var _x = 0;
   var _y = 0;
   var _mx = 0;
   var _my = 0;
   var _vx = 0;
   var _vy = 0;
   var _w = 50;
   var _h = 50;
   var _wd2 = 25;
   var _hd2 = 25;
   var _tgf = 0;
   var _touchground = false;
   var _touchbloc = false;
   var _canjump = false;
   var _tx = 0;
   var _ty = 0;
   var _ta = 0;
   var _tl = 0.2;
   var _sustain = 0.98;
   var _blocsustain = 1;
   var _AIlevel = 1;
   var _AIPower = 10;
   var _randomjumplimit = 0;
   var _jf = 15;
   var _sf = 0;
   var _rank = 0;
   static var _rebond = 1.35;
   var _burstcount = 100;
   var _burst = false;
   var _lastjump = 0;
   var _diffpos = 0.005;
   function Mammoth(mc, mc2, mc3, x, y, w, h, tl, ail, aip, jf, sf)
   {
      this._mc = mc;
      this._mc2 = mc2;
      this._mc2dx = this._mc2._x - this._mc._x;
      this._mc2dy = this._mc2._y - this._mc._y;
      this._mc3 = mc3;
      this._mc3dx = this._mc3._x - this._mc._x;
      this._mc3dy = this._mc3._y - this._mc._y;
      this._x = x;
      this._y = y;
      this._w = w;
      this._h = h;
      this._wd2 = w / 2;
      this._hd2 = h / 2;
      this._tl = tl;
      this._jf = jf;
      this._sf = sf;
      this.setPos(0,1);
      this._mc.mamo.tl.createEmptyMovieClip("tail",1);
      this._mc.mamo.tl.pompom.swapDepth(1);
      Mammoth._choclimit = 8 * _root.GRAVITY;
      this._AIlevel = ail;
      this._AIPower = aip;
      this._randomjumplimit = 2 - this._AIPower / 5;
      this.windposx = this._mc.ice.wind._x;
      this.windposy = this._mc.ice.wind._y;
   }
   function init2()
   {
      this._mc.ice.wind._visible = true;
   }
   function memo()
   {
      this._mx = this._x;
      this._my = this._y;
      this._touchbloc = false;
   }
   function moveMamo()
   {
      this._vx += _root._fx;
      this._vy += _root._fy;
      this._vx *= this._sustain * this._blocsustain;
      this._vy *= this._sustain * this._blocsustain;
      this._x += this._vx;
      this._y += this._vy;
      this._blocsustain = 1;
   }
   function ground()
   {
      if(this._y + this._hd2 > 115)
      {
         this._touchground = true;
         this._y = 115 - this._hd2;
      }
      else
      {
         this._touchground = false;
      }
   }
   function hitMamo(mamo)
   {
      var _loc9_ = Math.abs(mamo._x - this._x);
      var _loc8_ = Math.abs(mamo._y - this._y);
      if(_loc9_ < mamo._wd2 + this._wd2 && _loc8_ < mamo._hd2 + this._hd2)
      {
         if(_loc9_ >= _loc8_)
         {
            var _loc4_ = Math.abs(this._vx - mamo._vx);
            if(_loc4_ > 3)
            {
               _root.choc(Math.abs((this._mc._x + mamo._mc._x) / 2),_loc4_ - 3);
            }
            var _loc5_ = (mamo._wd2 + this._wd2 - _loc9_) / 2;
            if(mamo._x > this._x)
            {
               if(mamo._vx < this._vx)
               {
                  mamo._mx += (mamo._vx - this._vx) * Mammoth._rebond;
                  this._mx += (this._vx - mamo._vx) * Mammoth._rebond;
               }
               else
               {
                  mamo._x += _loc5_;
                  this._x -= _loc5_;
                  mamo._mx += _loc5_;
                  this._mx -= _loc5_;
               }
            }
            else if(mamo._vx > this._vx)
            {
               mamo._mx += (mamo._vx - this._vx) * Mammoth._rebond;
               this._mx += (this._vx - mamo._vx) * Mammoth._rebond;
            }
            else
            {
               mamo._x -= _loc5_;
               this._x += _loc5_;
               mamo._mx -= _loc5_;
               this._mx += _loc5_;
            }
         }
         else
         {
            var _loc7_ = (mamo._hd2 + this._hd2 - _loc8_) / 2;
            var _loc6_ = 0.9;
            _loc4_ = Math.abs(this._vy - mamo._vy);
            if(_loc4_ > 3)
            {
               _root.choc(Math.abs((this._mc._x + mamo._mc._x) / 2),_loc4_ - 3);
            }
            if(mamo._y > this._y)
            {
               mamo._y += _loc7_;
               this._y -= _loc7_;
               this._touchbloc = true;
               if(_loc4_ > Mammoth._choclimit)
               {
                  var _loc10_ = mamo._vx + this._vx;
                  if(_loc10_ > 0)
                  {
                     if(this._x + this._wd2 < mamo._x + mamo._wd2)
                     {
                        this._blocsustain = _loc6_ - (_loc4_ - Mammoth._choclimit) / 100;
                        this._mc.ice.braker.gotoAndPlay(2);
                        _root.pchit(Math.abs(this._mc._x),_loc4_ - Mammoth._choclimit);
                     }
                  }
                  else if(this._x - this._wd2 > mamo._x - mamo._wd2)
                  {
                     this._blocsustain = _loc6_ - (_loc4_ - Mammoth._choclimit) / 100;
                     this._mc.ice.brakel.gotoAndPlay(2);
                     _root.pchit(Math.abs(this._mc._x),_loc4_ - Mammoth._choclimit);
                  }
               }
            }
            else
            {
               mamo._y -= _loc7_;
               this._y += _loc7_;
               mamo._touchbloc = true;
               if(_loc4_ > Mammoth._choclimit)
               {
                  _loc10_ = mamo._vx + this._vx;
                  if(_loc10_ > 0)
                  {
                     if(this._x + this._wd2 > mamo._x + mamo._wd2)
                     {
                        mamo._blocsustain = _loc6_ - (_loc4_ - Mammoth._choclimit) / 100;
                        mamo._mc.ice.braker.gotoAndPlay(2);
                        _root.pchit(Math.abs(mamo._mc._x),_loc4_ - Mammoth._choclimit);
                     }
                  }
                  else if(this._x - this._wd2 < mamo._x - mamo._wd2)
                  {
                     mamo._blocsustain = _loc6_ - (_loc4_ - Mammoth._choclimit) / 100;
                     mamo._mc.ice.brakel.gotoAndPlay(2);
                     _root.pchit(Math.abs(mamo._mc._x),_loc4_ - Mammoth._choclimit);
                  }
               }
            }
         }
      }
   }
   function showMamo()
   {
      this._ta += this._vx * 0.05;
      this._mc3.gotoAndStop(Math.round(20 + Math.cos(this._ta * 0.4) * 20));
      this._tx += ((- this._vx) * 2 - this._tx) * this._tl;
      this._ty += ((- this._vy) * 15 + 30 - this._ty) * this._tl + Math.cos(this._ta) * 13;
      this._mc.mamo.tl.pompom._x = this._tx;
      this._mc.mamo.tl.pompom._y = this._ty;
      this._mc.mamo.tl.tail.clear();
      this._mc.mamo.tl.tail.lineStyle(2,5588019,100);
      this._mc.mamo.tl.tail.moveTo(0,0);
      this._mc.mamo.tl.tail.curveTo(-20,0,this._tx,this._ty);
      this._mc._x = this._x + _root._xtrans;
      this._mc._y = this._y;
      this._mc2._x = this._mc._x + this._mc2dx;
      this._mc2._y = this._mc._y + this._mc2dy;
      this._mc3._x = this._mc._x + this._mc3dx;
      this._mc3._y = this._mc._y + this._mc3dy;
      if(this._vx > 0)
      {
         var _loc4_ = Math.pow((3 - this._rank) / 3,4);
         if(this._vx < 2)
         {
            _loc4_ *= this._vx / 2;
         }
         var _loc3_ = Math.pow((3 - this._rank) / 3,2);
         this._mc.ice.wind._alpha = this._vx * 0.65 + 40 * _loc4_;
         this._mc.ice.wind._x = this.windposx + (random(21) - 10) * 0.03 * this._vx * _loc3_;
         this._mc.ice.wind._y = this.windposy + (random(21) - 10) * 0.03 * this._vx * _loc3_;
      }
      else
      {
         this._mc.ice.wind._alpha = 0;
      }
   }
   function speed()
   {
      this._vx = this._x - this._mx;
      this._vy = this._y - this._my;
      if(this._touchground || this._touchbloc)
      {
         this._tgf = this._tgf + 1;
         if(this._tgf > 1)
         {
            this._canjump = true;
         }
      }
      else
      {
         this._tgf = 0;
         this._canjump = false;
      }
   }
   function quickLoop()
   {
      if(!this._burst)
      {
         if(this._burstcount < 100)
         {
            this._burstcount += 1;
         }
      }
   }
   function setPos(pos)
   {
      this._rank = pos;
   }
   function setSustain(pos, posmax)
   {
      this._sustain += (0.98 + this._sf + pos * this._diffpos / posmax - this._sustain) * 0.05;
   }
   function jump()
   {
      this._vy -= this._jf;
      this._tgf = 0;
      this._canjump = false;
      this._lastjump = _root._frame;
   }
   function burst(b)
   {
   }
   function catchCp()
   {
      this._mc.ice.catchcp.gotoAndPlay(2);
      this._mc.ice.light.gotoAndPlay(2);
   }
   function quickAI()
   {
      if(this._canjump)
      {
         if(this._AIlevel == 0)
         {
            if(random(10) < this._randomjumplimit + 2)
            {
               this.jump();
            }
         }
         else if(this._AIlevel >= 1)
         {
            if(random(50) < this._randomjumplimit)
            {
               this.jump();
            }
            else
            {
               if(this._rank > 0)
               {
                  if(this._vx > 0)
                  {
                     var _loc3_ = _root._mamos[_root._ranks[this._rank - 1]];
                     var _loc5_ = _loc3_._x - _loc3_._wd2 - (this._x + this._wd2);
                     if(_loc5_ > 0)
                     {
                        var _loc4_ = this._vx - _loc3_._vx;
                        if(_loc5_ < _loc4_ * 14 + (10 - random(20)))
                        {
                           this.jump();
                        }
                     }
                  }
               }
               if(this._AIlevel >= 2 || this._rank == 0)
               {
                  _loc3_ = _root._mamos[_root._ranks[this._rank + 1]];
                  _loc4_ = _loc3_._vx - this._vx;
                  _loc5_ = this._x - this._wd2 - (_loc3_._x + _loc3_._wd2);
                  if(_loc3_._y < this._y - this._hd2)
                  {
                     if(_loc4_ > 0 && _loc5_ < _loc4_ * 5)
                     {
                        this.jump();
                     }
                  }
                  else if(_loc4_ > 0 && _loc5_ < _loc4_)
                  {
                     this.jump();
                  }
               }
            }
         }
      }
   }
}
