function initMenu()
{
   clearInterval(doOnce0);
   enduranceBtn.setText("CHALLENGE",true);
   enduranceBtn.action = function()
   {
      _root.endurancePlay();
   };
   multiplayerBtn.setText("4 PLAYERS",true);
   multiplayerBtn.action = function()
   {
      _root.multiplayerPlay();
   };
   raceBtn.setText("CHAMPIONSHIP",true);
   raceBtn.action = function()
   {
      _root.racePlay();
   };
   if(!_onpepere)
   {
      highBtn.setText("HIGHSCORES",2);
      highBtn.action = function()
      {
         getURL(GAMEURL,"_blank");
      };
      moreBtn.setText("PLAY MORE GAMES",2);
      moreBtn.action = function()
      {
         getUrl("http://www.pepere.org/", "_blank");
      };
   }
   else
   {
      highBtn._visible = false;
      moreBtn._visible = false;
   }
   creditBtn.setText("CREDITS",2);
   creditBtn.action = function()
   {
      _root.creditPlay();
   };
   windSound.stop();
}
function endurancePlay()
{
   if(!fading)
   {
      fading = true;
      transit.gotoFrame("chmenu");
   }
}
function multiplayerPlay()
{
   if(levelUnlock() <= 0)
   {
      multiplayerStart();
   }
   else if(!fading)
   {
      fading = true;
      transit.gotoFrame("multikeys");
   }
}
function multiplayerStart()
{
   if(!fading)
   {
      fading = true;
      tracknb = 0;
      transit.gotoFrame("multiplayer");
   }
}
function racePlay()
{
   if(!fading)
   {
      fading = true;
      transit.gotoFrame("track");
   }
}
function creditPlay()
{
   if(!fading)
   {
      fading = true;
      transit.gotoFrame("credits");
   }
}
function levelUnlock()
{
   var _loc2_ = 0;
   if(rcscores + "" != "undefined")
   {
      var _loc1_ = 0;
      while(_loc1_ < 3)
      {
         if(rcscores[_loc1_] + "" != "undefined")
         {
            if(rcscores[_loc1_][0].win == true)
            {
               _loc2_ = _loc1_ + 1;
            }
         }
         _loc1_ = _loc1_ + 1;
      }
   }
   return _loc2_;
}
function cleanTips()
{
   tip0._visible = tip1._visible = tip2._visible = tip3._visible = curs._visible = bests._visible = false;
}
function scoreTips()
{
   bests._y = curs._y = 375;
   bests.help.text = "BEST";
   bests.setYbase();
   bests._visible = true;
   curs.help.text = "SCORE";
   curs.setYbase();
   curs._visible = true;
}
function mainMenu()
{
   if(!fading)
   {
      fading = true;
      transit.gotoFrame("menu");
   }
}
function hidePanel()
{
   panel.hidePanel();
}
function cleanMamos()
{
   var _loc2_ = _nbMamosTotal - 1;
   while(_loc2_ >= 0)
   {
      rotator["m" + _loc2_]._visible = false;
      rotator["def" + _loc2_]._visible = false;
      rotator["hair" + _loc2_]._visible = false;
      _root["num" + _loc2_]._visible = false;
      _root["sc" + _loc2_]._visible = false;
      _root["sc" + _loc2_].neon._visible = false;
      _root["sc" + _loc2_].neon2._visible = false;
      _loc2_ = _loc2_ - 1;
   }
}
function initMultiSounds()
{
   var _loc1_ = 0;
   while(_loc1_ < 4)
   {
      pchitSounds[_loc1_].f = -100;
      chocSounds[_loc1_].f = -100;
      _loc1_ = _loc1_ + 1;
   }
}
function pchit(d, frc)
{
   var _loc1_ = 0;
   while(_loc1_ < 4)
   {
      if(pchitSounds[_loc1_].f + 100 < _frame)
      {
         if(d > 300)
         {
            d = 300;
         }
         if(frc > 10)
         {
            frc = 10;
         }
         var _loc2_ = (300 - d) * frc / 30;
         if(_loc2_ < 10)
         {
            _loc2_ = 10;
         }
         pchitSounds[_loc1_].f = _frame;
         pchitSounds[_loc1_].s.setVolume(_loc2_ / 2);
         pchitSounds[_loc1_].s.start(0,1);
         break;
      }
      _loc1_ = _loc1_ + 1;
   }
}
function choc(d, frc)
{
   var _loc1_ = 0;
   while(_loc1_ < 4)
   {
      if(chocSounds[_loc1_].f + 100 < _frame)
      {
         if(d > 300)
         {
            d = 300;
         }
         frc *= 2;
         if(frc > 10)
         {
            frc = 10;
         }
         var _loc2_ = (300 - d) * frc / 30;
         if(_loc2_ < 10)
         {
            _loc2_ = 10;
         }
         chocSounds[_loc1_].f = _frame;
         chocSounds[_loc1_].s.setVolume(_loc2_);
         chocSounds[_loc1_].s.start(0,1);
         break;
      }
      _loc1_ = _loc1_ + 1;
   }
}
function getTotalScore()
{
   var _loc2_ = 0;
   var _loc1_ = 0;
   while(_loc1_ < 3)
   {
      _loc2_ += chscores[_loc1_][0].rs;
      if(rcscores[_loc1_][0].win)
      {
         _loc2_ += rcscores[_loc1_][0].rs;
      }
      _loc1_ = _loc1_ + 1;
   }
   yourscore.myscores.text = "YOUR SCORE : " + _loc2_ + " CHAMPIONSHIP : " + rcscores[0][0].rs + " + " + rcscores[1][0].rs + " + " + rcscores[2][0].rs + " CHALLENGE : " + chscores[0][0].rs + " + " + chscores[1][0].rs + " + " + chscores[2][0].rs;
   return _loc2_;
}
function save()
{
   var _loc4_ = "1";
   var _loc3_ = 0;
   while(_loc3_ < 3)
   {
      _loc4_ += "_" + chscores[_loc3_][0].rs;
      _loc3_ = _loc3_ + 1;
   }
   _loc3_ = 0;
   while(_loc3_ < 3)
   {
      if(rcscores[_loc3_][0].win)
      {
         _loc4_ += "_" + rcscores[_loc3_][0].rs;
      }
      else
      {
         _loc4_ += "_0";
      }
      _loc3_ = _loc3_ + 1;
   }
   _loc4_ += "_";
   if(!peperemember)
   {
      local_data.data.scores0 = _loc4_;
      local_data.flush();
      return undefined;
   }
   srecord = new LoadVars();
   srecord.params = _root.gid;
   srecord.data = _loc4_;
   srecord.score = getTotalScore();
   if(srecord.score <= bestscore)
   {
      return undefined;
   }
   bestscore = srecord.score;
   srecord.sendAndLoad("record.php",srecord,"POST");
   srecord.onLoad = function()
   {
      if(this.result + "" != "undefined" && this.result > 0)
      {
      }
      var _loc2_ = Number(this.recordid);
      if(_loc2_ + "" != "NaN")
      {
      }
   };
}
function parseData(s)
{
   var _loc3_ = 0;
   var _loc2_ = -1;
   _loc3_ = _loc2_ + 1;
   _loc2_ = s.indexOf("_",_loc3_);
   if(_loc2_ == -1)
   {
      return false;
   }
   var _loc5_ = Number(s.substring(_loc3_,_loc2_));
   if(_loc5_ == "1" && _loc3_ != -1)
   {
      _loc3_ = _loc2_ + 1;
      _loc2_ = s.indexOf("_",_loc3_);
      if(_loc2_ == -1)
      {
         return false;
      }
      chscores[0][0].rs = Number(s.substring(_loc3_,_loc2_));
      _loc3_ = _loc2_ + 1;
      _loc2_ = s.indexOf("_",_loc3_);
      if(_loc2_ == -1)
      {
         return false;
      }
      chscores[1][0].rs = Number(s.substring(_loc3_,_loc2_));
      _loc3_ = _loc2_ + 1;
      _loc2_ = s.indexOf("_",_loc3_);
      if(_loc2_ == -1)
      {
         return false;
      }
      chscores[2][0].rs = Number(s.substring(_loc3_,_loc2_));
      _loc3_ = _loc2_ + 1;
      _loc2_ = s.indexOf("_",_loc3_);
      if(_loc2_ == -1)
      {
         return false;
      }
      rcscores[0][0].rs = Number(s.substring(_loc3_,_loc2_));
      if(rcscores[0][0].rs > 0)
      {
         rcscores[0][0].win = true;
      }
      _loc3_ = _loc2_ + 1;
      _loc2_ = s.indexOf("_",_loc3_);
      if(_loc2_ == -1)
      {
         return false;
      }
      rcscores[1][0].rs = Number(s.substring(_loc3_,_loc2_));
      if(rcscores[1][0].rs > 0)
      {
         rcscores[1][0].win = true;
      }
      _loc3_ = _loc2_ + 1;
      _loc2_ = s.indexOf("_",_loc3_);
      if(_loc2_ == -1)
      {
         return false;
      }
      rcscores[2][0].rs = Number(s.substring(_loc3_,_loc2_));
      if(rcscores[2][0].rs > 0)
      {
         rcscores[2][0].win = true;
      }
      _root.bestscore = _root.getTotalScore();
      if(_root._frame < 80)
      {
         _root._startscoreframe = 80;
      }
      else
      {
         _root._startscoreframe = _root._frame;
      }
   }
}
function loadMyscore()
{
   if(!peperemember)
   {
      var _loc3_ = local_data.data.scores0;
      if(_loc3_)
      {
         parseData(_loc3_);
      }
      return undefined;
   }
   demandeParcours = new LoadVars();
   demandeParcours.params = _root.gid;
   demandeParcours.sendAndLoad("get_mydata.php",demandeParcours,"POST");
   demandeParcours.onLoad = function()
   {
      var _loc2_ = this.data;
      parseData(_loc2_);
   };
}
stop();
var mamorot = 0;
var tracknb;
var doOnce0 = setInterval(initMenu,1);
var fading = false;
cleanTips();
var _frame = 0;
var BTNY = 180;
var _btns = [raceBtn,enduranceBtn,multiplayerBtn,highBtn,moreBtn,creditBtn];
var i = 0;
while(i < _btns.length)
{
   _btns[i]._y = 500;
   i++;
}
mammoths._y = -200;
crazy._y = -200;
var _startscoreframe = -100;
onEnterFrame = function()
{
   mamorot += 5;
   hairmenu.gotoAndStop(Math.round(19 + 13 * Math.cos(mamorot * 0.05) * Math.cos(mamorot * 0.001)));
   if(bodjump)
   {
      tail._rotation = Math.cos(mamorot * 0.3) * 15;
   }
   else
   {
      tail._rotation = Math.cos(mamorot * 0.03) * 5;
   }
   _frame++;
   if(_frame < 200)
   {
      var _loc1_ = 0;
      while(_loc1_ < _btns.length)
      {
         if(_frame > _loc1_ * 10 && _frame < _loc1_ * 10 + 100)
         {
            _btns[_loc1_]._y += (BTNY + 36 * _loc1_ - _btns[_loc1_]._y) * 0.1;
         }
         _loc1_ = _loc1_ + 1;
      }
      if(_frame > 50 && _frame < 85)
      {
         mammoths._y += (55 - mammoths._y) * 0.3;
      }
      if(_frame > 70 && _frame < 78)
      {
         crazy._y += (- crazy._y) * 0.3;
         if(_frame == 71)
         {
            tip0.help.text = "V " + VERSION;
            tip0._x = 500;
            tip0._y = 50;
            tip0.setYbase();
            tip0._visible = true;
            tip0._alpha = 0;
         }
         tip0._alpha += 20;
         if(tip0._alpha > 100)
         {
            tip0._alpha = 100;
         }
      }
   }
   if(_frame - _startscoreframe < 100 && _frame - _startscoreframe >= 0)
   {
      yourscore._x += (275 - yourscore._x) * 0.1;
   }
   if(pingjump)
   {
      ping.w0._rotation = -60 - Math.cos(_frame * 0.6) * 30;
      ping.w1._rotation = 60 + Math.cos(_frame * 0.6) * 30;
   }
   else
   {
      ping.w0._rotation = -40 + Math.cos(_frame * 0.03) * 10;
      ping.w1._rotation = 40 + Math.cos(_frame * 0.03) * 10;
   }
   ping.eyes.gotoAndStop(Math.round(25 + Math.cos(_frame * 0.03) * 24));
   if(bodjump)
   {
      var _loc3_ = (_frame - bodjump) * 0.2;
      if(_loc3_ > 3.141592653589793)
      {
         bodjump = false;
      }
      var _loc2_ = 80 * Math.sin(_loc3_);
      bod._y = bodbasey - _loc2_;
      tail._y = tailbasey - _loc2_;
      hairmenu._y = hairbasey - _loc2_;
      def._y = defbasey - _loc2_;
      eye._y = eyebasey - _loc2_;
      bodshad._x = bodshadbasex + 1 * _loc2_;
      bodshad._y = bodshadbasey + 1 * _loc2_;
   }
   if(pingjump)
   {
      _loc3_ = (_frame - pingjump) * 0.2;
      if(_loc3_ > 3.141592653589793)
      {
         pingjump = false;
      }
      _loc2_ = 40 * Math.sin(_loc3_);
      ping._y = pingbasey - _loc2_;
      pingshad._x = pingshadbasex + 1 * _loc2_;
      pingshad._y = pingshadbasey + 1 * _loc2_;
   }
};
var bodjump = false;
var bodbasey = bod._y;
var tailbasey = tail._y;
var hairbasey = hairmenu._y;
var defbasey = def._y;
var eyebasey = eye._y;
var bodshadbasex = bodshad._x;
var bodshadbasey = bodshad._y;
bod.onPress = function()
{
   bariSound.start(0,1);
   eye.gotoAndPlay("blink");
   bodjump = _frame;
};
var pingjump = false;
var pingbasey = ping._y;
var pingshadbasex = pingshad._x;
var pingshadbasey = pingshad._y;
ping.onPress = function()
{
   flySound.start(0,1);
   pingjump = _frame;
};
var _nbMamosTotal = 10;
var mamosParams = new Array();
mamosParams[0] = {num:23,wh:50,tl:0.2,ail:0,aip:1,jf:15,sf:0};
mamosParams[1] = {num:69,wh:60,tl:0.1,ail:2,aip:10,jf:15,sf:0};
mamosParams[2] = {num:6,wh:40,tl:0.2,ail:1,aip:6,jf:17,sf:0};
mamosParams[3] = {num:10,wh:50,tl:0.3,ail:0,aip:5,jf:15,sf:0};
mamosParams[4] = {num:73,wh:70,tl:0.1,ail:2,aip:4,jf:15,sf:0.0005};
mamosParams[5] = {num:3,wh:55,tl:0.2,ail:1,aip:7,jf:20,sf:0.0002};
mamosParams[6] = {num:13,wh:50,tl:0.05,ail:2,aip:10,jf:25,sf:0.0002};
mamosParams[7] = {num:66,wh:92,tl:0.05,ail:2,aip:9,jf:20,sf:0.0006};
mamosParams[8] = {num:9,wh:60,tl:0.3,ail:2,aip:9,jf:22,sf:0.0005};
mamosParams[9] = {num:33,wh:70,tl:0.1,ail:2,aip:9,jf:12,sf:0.0009};
keyListener.onKeyDown = null;
keyListener.onKeyUp = null;
if(varinited + "" == "undefined")
{
   var varinited = true;
   var bariSound = new Sound();
   bariSound.attachSound("BariSound");
   var lineSound = new Sound();
   lineSound.attachSound("LineSound");
   var menuSound = new Sound();
   menuSound.attachSound("MenuSound");
   var winSound = new Sound();
   winSound.attachSound("WinSound");
   var looseSound = new Sound();
   looseSound.attachSound("LooseSound");
   var flySound = new Sound();
   flySound.attachSound("FlySound");
   createEmptyMovieClip("WindSoundMC",10000000);
   var windSound = new Sound(WindSoundMC);
   windSound.attachSound("WindSound");
   var pchitSounds = [{s:null,f:-100},{s:null,f:-100},{s:null,f:-100},{s:null,f:-100}];
   createEmptyMovieClip("PchitSoundMC0",10000001);
   pchitSounds[0].s = new Sound(PchitSoundMC0);
   pchitSounds[0].s.attachSound("PchitSound");
   createEmptyMovieClip("PchitSoundMC1",10000002);
   pchitSounds[1].s = new Sound(PchitSoundMC1);
   pchitSounds[1].s.attachSound("PchitSound");
   createEmptyMovieClip("PchitSoundMC2",10000003);
   pchitSounds[2].s = new Sound(PchitSoundMC2);
   pchitSounds[2].s.attachSound("PchitSound");
   createEmptyMovieClip("PchitSoundMC3",10000004);
   pchitSounds[3].s = new Sound(PchitSoundMC3);
   pchitSounds[3].s.attachSound("PchitSound");
   var chocSounds = [{s:null,f:-100},{s:null,f:-100},{s:null,f:-100},{s:null,f:-100}];
   createEmptyMovieClip("ChocSoundMC0",10000005);
   chocSounds[0].s = new Sound(ChocSoundMC0);
   chocSounds[0].s.attachSound("ChocSound");
   createEmptyMovieClip("ChocSoundMC1",10000006);
   chocSounds[1].s = new Sound(ChocSoundMC1);
   chocSounds[1].s.attachSound("ChocSound");
   createEmptyMovieClip("ChocSoundMC2",10000007);
   chocSounds[2].s = new Sound(ChocSoundMC2);
   chocSounds[2].s.attachSound("ChocSound");
   createEmptyMovieClip("ChocSoundMC3",10000008);
   chocSounds[3].s = new Sound(ChocSoundMC3);
   chocSounds[3].s.attachSound("ChocSound");
   var local_data = SharedObject.getLocal("user_data");
   var players = [0,1,2,3];
   loadMyscore();
   var bestscore = 0;
}
else
{
   bestscore = getTotalScore();
   if(_frame < 80)
   {
      _startscoreframe = 80;
   }
   else
   {
      _startscoreframe = _frame;
   }
}
bariSound.start(0,1);
TUTO1 = "THE HIGHER POSITION YOU TAKE DURING THE RACE, THE MORE YOU ARE SLOWED DOWN BY THE FRICTION WITH THE AIR!";
var TUTO2 = "WHEN A CRAZY MAMMOTH JUMPS OVER YOU, HIT THE LOWER RIGHT CORNER OF HIS ICE BLOCK TO STOP IT!";
